import { NodeSchema } from '@alilc/lowcode-types';
import { History as ShellHistory } from '@alilc/lowcode-shell';
export interface Serialization<T = any> {
    serialize(data: NodeSchema): T;
    unserialize(data: T): NodeSchema;
}
export declare function setSerialization(serialization: Serialization): void;
export declare class History {
    private redoer;
    private timeGap;
    private session;
    private records;
    private point;
    private emitter;
    private asleep;
    constructor(logger: () => any, redoer: (data: NodeSchema) => void, timeGap?: number);
    get hotData(): any;
    isSavePoint(): boolean;
    private sleep;
    private wakeup;
    go(cursor: number): void;
    back(): void;
    forward(): void;
    savePoint(): void;
    /**
     *  |    1     |     1    |    1     |
     *  | -------- | -------- | -------- |
     *  | modified | redoable | undoable |
     */
    getState(): number;
    onStateChange(func: () => any): () => void;
    onCursor(func: () => any): () => void;
    destroy(): void;
    /**
     *
     * @deprecated
     * @returns
     * @memberof History
     */
    isModified(): boolean;
    internalToShellHistory(): ShellHistory;
}
