"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _initializerDefineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/initializerDefineProperty"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));

var _initializerWarningHelper2 = _interopRequireDefault(require("@babel/runtime/helpers/initializerWarningHelper"));

var _react = require("react");

var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");

var _dragon = require("../dragon");

var _simulator = require("../../simulator");

require("./ghost.less");

var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4;

var DragGhost = (_dec = _lowcodeEditorCore.obx.ref, _dec2 = _lowcodeEditorCore.obx.ref, _dec3 = _lowcodeEditorCore.obx.ref, (0, _lowcodeEditorCore.observer)(_class = (_class2 = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(DragGhost, _Component);

  function DragGhost(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.dispose = [];
    (0, _initializerDefineProperty2["default"])(_this, "dragObject", _descriptor, (0, _assertThisInitialized2["default"])(_this));
    (0, _initializerDefineProperty2["default"])(_this, "x", _descriptor2, (0, _assertThisInitialized2["default"])(_this));
    (0, _initializerDefineProperty2["default"])(_this, "y", _descriptor3, (0, _assertThisInitialized2["default"])(_this));
    (0, _initializerDefineProperty2["default"])(_this, "isAbsoluteLayoutContainer", _descriptor4, (0, _assertThisInitialized2["default"])(_this));
    _this.dragon = _this.props.designer.dragon;
    (0, _lowcodeEditorCore.makeObservable)((0, _assertThisInitialized2["default"])(_this));
    _this.dispose = [_this.dragon.onDragstart(function (e) {
      if (e.originalEvent.type.substr(0, 4) === 'drag') {
        return;
      }

      _this.dragObject = e.dragObject;
      _this.x = e.globalX;
      _this.y = e.globalY;
    }), _this.dragon.onDrag(function (e) {
      _this.x = e.globalX;
      _this.y = e.globalY;

      if ((0, _simulator.isSimulatorHost)(e.sensor)) {
        var _container$container$;

        var container = e.sensor.getDropContainer(e);

        if (container !== null && container !== void 0 && (_container$container$ = container.container.componentMeta.getMetadata().configure.advanced) !== null && _container$container$ !== void 0 && _container$container$.isAbsoluteLayoutContainer) {
          _this.isAbsoluteLayoutContainer = true;
          return;
        }
      }

      _this.isAbsoluteLayoutContainer = false;
    }), _this.dragon.onDragend(function () {
      _this.dragObject = null;
      _this.x = 0;
      _this.y = 0;
    })];
    return _this;
  }

  var _proto = DragGhost.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    if (this.dispose) {
      this.dispose.forEach(function (off) {
        return off();
      });
    }
  };

  _proto.renderGhostGroup = function renderGhostGroup() {
    var dragObject = this.dragObject;

    if ((0, _dragon.isDragNodeObject)(dragObject)) {
      return dragObject.nodes.map(function (node) {
        var ghost = /*#__PURE__*/React.createElement("div", {
          className: "lc-ghost",
          key: node.id
        }, /*#__PURE__*/React.createElement(_lowcodeEditorCore.Title, {
          title: node.title
        }));
        return ghost;
      });
    } else if ((0, _dragon.isDragNodeDataObject)(dragObject)) {
      return Array.isArray(dragObject.data) ? dragObject.data.map(function (item, index) {
        return /*#__PURE__*/React.createElement("div", {
          className: "lc-ghost",
          key: "ghost-" + index
        }, /*#__PURE__*/React.createElement("div", {
          className: "lc-ghost-title"
        }, item.componentName));
      }) : /*#__PURE__*/React.createElement("div", {
        className: "lc-ghost"
      }, /*#__PURE__*/React.createElement("div", {
        className: "lc-ghost-title"
      }, dragObject.data.componentName));
    }
  };

  _proto.render = function render() {
    if (!this.dragObject) {
      return null;
    }

    if (this.isAbsoluteLayoutContainer) {
      return null;
    }

    return /*#__PURE__*/React.createElement("div", {
      className: "lc-ghost-group",
      style: {
        left: this.x,
        top: this.y
      }
    }, this.renderGhostGroup());
  };

  return DragGhost;
}(_react.Component), (_descriptor = (0, _applyDecoratedDescriptor2["default"])(_class2.prototype, "dragObject", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return null;
  }
}), _descriptor2 = (0, _applyDecoratedDescriptor2["default"])(_class2.prototype, "x", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return 0;
  }
}), _descriptor3 = (0, _applyDecoratedDescriptor2["default"])(_class2.prototype, "y", [_dec3], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return 0;
  }
}), _descriptor4 = (0, _applyDecoratedDescriptor2["default"])(_class2.prototype, "isAbsoluteLayoutContainer", [_lowcodeEditorCore.obx], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
})), _class2)) || _class);
exports["default"] = DragGhost;