"use strict";

exports.__esModule = true;
exports.Transducer = void 0;

var _react = require("react");

var _lowcodeTypes = require("@alilc/lowcode-types");

var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");

// all this file for polyfill vision logic
function getHotterFromSetter(setter) {
  return setter && (setter.Hotter || setter.type && setter.type.Hotter) || []; // eslint-disable-line
}

function getTransducerFromSetter(setter) {
  return setter && (setter.transducer || setter.Transducer || setter.type && (setter.type.transducer || setter.type.Transducer)) || null; // eslint-disable-line
}

function combineTransducer(transducer, arr, context) {
  if (!transducer && Array.isArray(arr)) {
    var toHot = arr[0],
        toNative = arr[1];
    transducer = {
      toHot: toHot,
      toNative: toNative
    };
  }

  return {
    toHot: (transducer && transducer.toHot || function (x) {
      return x;
    }).bind(context),
    // eslint-disable-line
    toNative: (transducer && transducer.toNative || function (x) {
      return x;
    }).bind(context) // eslint-disable-line

  };
}

var Transducer = /*#__PURE__*/function () {
  function Transducer(context, config) {
    this.setterTransducer = void 0;
    this.context = void 0;
    var setter = config.setter; // 1. validElement
    // 2. SetterConfig
    // 3. SetterConfig[]

    if (Array.isArray(setter)) {
      setter = setter[0];
    } else if ( /*#__PURE__*/(0, _react.isValidElement)(setter) && setter.type.displayName === 'MixedSetter') {
      var _setter$props, _setter$props$setters;

      setter = (_setter$props = setter.props) === null || _setter$props === void 0 ? void 0 : (_setter$props$setters = _setter$props.setters) === null || _setter$props$setters === void 0 ? void 0 : _setter$props$setters[0];
    } else if (typeof setter === 'object' && setter.componentName === 'MixedSetter') {
      setter = setter && setter.props && setter.props.setters && Array.isArray(setter.props.setters) && setter.props.setters[0];
    }

    if ((0, _lowcodeTypes.isSetterConfig)(setter)) {
      setter = setter.componentName;
    }

    if (typeof setter === 'string') {
      var _getSetter;

      setter = (_getSetter = (0, _lowcodeEditorCore.getSetter)(setter)) === null || _getSetter === void 0 ? void 0 : _getSetter.component;
    }

    if ((0, _lowcodeTypes.isDynamicSetter)(setter)) {
      setter = setter.call(context, context);
    }

    this.setterTransducer = combineTransducer(getTransducerFromSetter(setter), getHotterFromSetter(setter), context);
    this.context = context;
  }

  var _proto = Transducer.prototype;

  _proto.toHot = function toHot(data) {
    return this.setterTransducer.toHot(data);
  };

  _proto.toNative = function toNative(data) {
    return this.setterTransducer.toNative(data);
  };

  return Transducer;
}();

exports.Transducer = Transducer;