import { EngineConfig } from '@alilc/lowcode-editor-core';
import { ILowCodePluginManager } from '@alilc/lowcode-designer';
import { Hotkey, Project, Skeleton, Setters, Material, Event, editorSymbol, designerSymbol, skeletonSymbol } from '@alilc/lowcode-shell';
import { Logger } from '@alilc/lowcode-utils';
import { ILowCodePluginContext, PluginContextOptions } from './plugin-types';
export default class PluginContext implements ILowCodePluginContext {
    private readonly [editorSymbol];
    private readonly [designerSymbol];
    private readonly [skeletonSymbol];
    hotkey: Hotkey;
    project: Project;
    skeleton: Skeleton;
    logger: Logger;
    setters: Setters;
    material: Material;
    config: EngineConfig;
    event: Event;
    plugins: ILowCodePluginManager;
    constructor(plugins: ILowCodePluginManager, options: PluginContextOptions);
}
