"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");

var _lowcodeShell = require("@alilc/lowcode-shell");

var _lowcodeUtils = require("@alilc/lowcode-utils");

var PluginContext = function PluginContext(plugins, options) {
  this[_lowcodeShell.editorSymbol] = void 0;
  this[_lowcodeShell.designerSymbol] = void 0;
  this[_lowcodeShell.skeletonSymbol] = void 0;
  this.hotkey = void 0;
  this.project = void 0;
  this.skeleton = void 0;
  this.logger = void 0;
  this.setters = void 0;
  this.material = void 0;
  this.config = void 0;
  this.event = void 0;
  this.plugins = void 0;
  var editor = this[_lowcodeShell.editorSymbol] = plugins.editor;
  var designer = this[_lowcodeShell.designerSymbol] = editor.get('designer');
  var skeleton = this[_lowcodeShell.skeletonSymbol] = editor.get('skeleton');
  var _options$pluginName = options.pluginName,
      pluginName = _options$pluginName === void 0 ? 'anonymous' : _options$pluginName;
  var project = designer === null || designer === void 0 ? void 0 : designer.project;
  this.hotkey = new _lowcodeShell.Hotkey();
  this.project = new _lowcodeShell.Project(project);
  this.skeleton = new _lowcodeShell.Skeleton(skeleton);
  this.setters = new _lowcodeShell.Setters();
  this.material = new _lowcodeShell.Material(editor);
  this.config = _lowcodeEditorCore.engineConfig;
  this.plugins = plugins;
  this.event = new _lowcodeShell.Event(editor, {
    prefix: 'common'
  });
  this.logger = (0, _lowcodeUtils.getLogger)({
    level: 'warn',
    bizName: "designer:plugin:" + pluginName
  });
};

exports["default"] = PluginContext;