import { Editor } from '@alilc/lowcode-editor-core';
import { ILowCodePlugin, ILowCodePluginConfig, ILowCodePluginManager, ILowCodePluginContext, LowCodeRegisterOptions } from './plugin-types';
export declare class LowCodePluginManager implements ILowCodePluginManager {
    private plugins;
    private pluginsMap;
    private editor;
    constructor(editor: Editor);
    private _getLowCodePluginContext;
    register(pluginConfigCreator: (ctx: ILowCodePluginContext, pluginOptions?: any) => ILowCodePluginConfig, pluginOptions?: any, options?: LowCodeRegisterOptions): Promise<void>;
    get(pluginName: string): ILowCodePlugin | undefined;
    getAll(): ILowCodePlugin[];
    has(pluginName: string): boolean;
    delete(pluginName: string): Promise<boolean>;
    init(): Promise<void>;
    destroy(): Promise<void>;
    get size(): number;
    toProxy(): this;
    setDisabled(pluginName: string, flag?: boolean): void;
    dispose(): Promise<void>;
}
