import { getSetter, registerSetter, getSettersMap } from '@alilc/lowcode-editor-core';
import { isFormEvent, compatibleLegaoSchema, getNodeSchemaById } from '@alilc/lowcode-utils';
import { isNodeSchema } from '@alilc/lowcode-types';
export declare type Setters = {
    getSetter: typeof getSetter;
    registerSetter: typeof registerSetter;
    getSettersMap: typeof getSettersMap;
};
export declare type NodeRemoveOptions = {
    suppressRemoveEvent?: boolean;
};
export declare const utils: {
    isNodeSchema: typeof isNodeSchema;
    isFormEvent: typeof isFormEvent;
    compatibleLegaoSchema: typeof compatibleLegaoSchema;
    getNodeSchemaById: typeof getNodeSchemaById;
};
export declare type Utils = typeof utils;
export declare enum PROP_VALUE_CHANGED_TYPE {
    /**
     * normal set value
     */
    SET_VALUE = "SET_VALUE",
    /**
     * value changed caused by sub-prop value change
     */
    SUB_VALUE_CHANGE = "SUB_VALUE_CHANGE"
}
export interface ISetValueOptions {
    disableMutator?: boolean;
    type?: PROP_VALUE_CHANGED_TYPE;
    fromSetHotValue?: boolean;
}
