"use strict";

exports.__esModule = true;
exports.isDOMNodeVisible = isDOMNodeVisible;
exports.isElementNode = isElementNode;

function isElementNode(domNode) {
  return domNode.nodeType === Node.ELEMENT_NODE;
}
/**
 * 判断节点是否在 viewport 内，判断依据：只要节点有一部分在 viewport 内，都算 true，其余情况 false
 * @param domNode 待检测的节点
 * @param viewport 画布 viewport
 * @returns 是否在 viewport 内
 */


function isDOMNodeVisible(domNode, viewport) {
  var domNodeRect = domNode.getBoundingClientRect();
  var _viewport$contentBoun = viewport.contentBounds,
      width = _viewport$contentBoun.width,
      height = _viewport$contentBoun.height;
  var left = domNodeRect.left,
      right = domNodeRect.right,
      top = domNodeRect.top,
      bottom = domNodeRect.bottom,
      nodeWidth = domNodeRect.width,
      nodeHeight = domNodeRect.height;
  return left >= -nodeWidth && top >= -nodeHeight && bottom <= height + nodeHeight && right <= width + nodeWidth;
}